#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Test dataframes created with plain lists of column names yield
# implicit schema inferences. We're not testing the schema anyway,
# so let assertions ignore it as needed.
# Also ignore row order if necessary, not relevant.

from chispa import assert_df_equality

from image_suggestions import slis


def test_combine_suggestions(spark_session):
    section_alignment = spark_session.createDataFrame(
        [
            (
                'aawiki',
                'Q1234',
                987654,
                321,
                'Aa_article_title',
                666,
                'Aa_heading',
                'Test_image_AA.jpg',
                'istype-section-alignment',
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'eswiki',
                'Q13446873',
                123456,
                789,
                'Article_title',
                42,
                'Heading',
                'Test_image.jpg',
                'istype-section-alignment',
                ['ptwiki', 'enwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_index',
            'target_section_heading',
            'suggested_image',
            'kind',
            'origin_wikis',
            'confidence',
        ],
    )
    section_topics = spark_session.createDataFrame(
        [
            (
                'bbwiki',
                'Q5678',
                'Q9999',
                654321,
                987,
                'Bb_article_title',
                4891,
                'Bb_heading',
                'Test_image_BB.jpg',
                'istype-section-topics',
                65,
            ),
            (
                'eswiki',
                'Q13446873',
                'Q9999',
                123456,
                789,
                'Article_title',
                42,
                'Heading',
                'Test_image.jpg',
                'istype-section-topics',
                57,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'topic_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_index',
            'target_section_heading',
            'suggested_image',
            'kind',
            'confidence',
        ],
    )
    actual = slis.combine_suggestions(section_alignment, section_topics)
    expected = spark_session.createDataFrame(
        [
            # found in section alignment only
            (
                'aawiki',
                'Q1234',
                987654,
                321,
                'Aa_article_title',
                666,
                'Aa_heading',
                'Test_image_AA.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            # found in section topics only
            (
                'bbwiki',
                'Q5678',
                654321,
                987,
                'Bb_article_title',
                4891,
                'Bb_heading',
                'Test_image_BB.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                65,
            ),
            # found in both; aggregate confidence score
            (
                'eswiki',
                'Q13446873',
                123456,
                789,
                'Article_title',
                42,
                'Heading',
                'Test_image.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                91,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_index',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )

    assert_df_equality(actual, expected, ignore_schema=True)


def test_prune_suggestions(spark_session, mocker):
    weekly_snapshot = '2023-02-03'
    suggestions = spark_session.createDataFrame(
        [
            (
                'aawiki',
                'Q1111',
                111111,
                11,
                'Aa_article_title',
                'Aa_heading',
                'Test_image_AA.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'bbwiki',
                'Q2222',
                222222,
                22,
                'Bb_article_title',
                'Bb_heading',
                'Test_image_BB.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
            (
                'ccwiki',
                'Q3333',
                333333,
                33,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
            (
                'ddwiki',
                'Q4444',
                444444,
                44,
                'Dd_article_title',
                'Dd_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ruwiki', 'idwiki'],
                80,
            ),
            (
                'eewiki',
                'Q5555',
                555555,
                55,
                'Ee_article_title',
                'Ee_heading',
                'Test_image_EE.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['gawiki'],
                80,
            ),
            (
                'ffwiki',
                'Q6666',
                666666,
                66,
                'Ff_article_title',
                'Ff_heading',
                'Test_image_FF.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['dewiki'],
                80,
            ),
            (
                'ggwiki',
                'Q7777',
                777777,
                77,
                'Gg_article_title',
                'Gg_heading',
                'Test_image_GG.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['enwiki'],
                80,
            ),
            (
                'hhwiki',
                'Q8888',
                888888,
                88,
                'Hh_article_title',
                'Hh_heading',
                'Test_image_HH.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['nlwiki'],
                80,
            ),
            (
                'iiwiki',
                'Q9999',
                999999,
                99,
                'Ii_article_title',
                'Ii_heading',
                'Test_image_II.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['frwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )
    mocker.patch(
        'image_suggestions.slis.prune_non_illustratable_item_ids',
        return_value=spark_session.createDataFrame(
            [
                (
                    'bbwiki',
                    'Q2222',
                    222222,
                    22,
                    'Bb_article_title',
                    'Bb_heading',
                    'Test_image_BB.jpg',
                    ['istype-section-topics'],
                    'Q9999',
                    None,
                    50,
                ),
                (
                    'ccwiki',
                    'Q3333',
                    333333,
                    33,
                    'Cc_article_title',
                    'Cc_heading',
                    'Test_image_CC.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['ptwiki', 'enwiki'],
                    80,
                ),
                (
                    'ddwiki',
                    'Q4444',
                    444444,
                    44,
                    'Dd_article_title',
                    'Dd_heading',
                    'Test_image_CC.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['ruwiki', 'idwiki'],
                    80,
                ),
                (
                    'eewiki',
                    'Q5555',
                    555555,
                    55,
                    'Ee_article_title',
                    'Ee_heading',
                    'Test_image_EE.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['gawiki'],
                    80,
                ),
                (
                    'ffwiki',
                    'Q6666',
                    666666,
                    66,
                    'Ff_article_title',
                    'Ff_heading',
                    'Test_image_FF.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['dewiki'],
                    80,
                ),
                (
                    'ggwiki',
                    'Q7777',
                    777777,
                    77,
                    'Gg_article_title',
                    'Gg_heading',
                    'Test_image_GG.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['enwiki'],
                    80,
                ),
                (
                    'hhwiki',
                    'Q8888',
                    888888,
                    88,
                    'Hh_article_title',
                    'Hh_heading',
                    'Test_image_HH.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['nlwiki'],
                    80,
                ),
                (
                    'iiwiki',
                    'Q9999',
                    999999,
                    99,
                    'Ii_article_title',
                    'Ii_heading',
                    'Test_image_II.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['frwiki'],
                    80,
                ),
            ],
            [
                'wiki_db',
                'target_qid',
                'target_page_rev_id',
                'target_page_id',
                'target_page_title',
                'target_section_heading',
                'suggested_image',
                'kind',
                'topic_qid',
                'origin_wikis',
                'confidence',
            ],
        ),
    )
    mocker.patch(
        'image_suggestions.slis.prune_non_illustratable_sections',
        return_value=spark_session.createDataFrame(
            [
                (
                    'ccwiki',
                    'Q3333',
                    333333,
                    33,
                    'Cc_article_title',
                    'Cc_heading',
                    'Test_image_CC.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['ptwiki', 'enwiki'],
                    80,
                ),
                (
                    'ddwiki',
                    'Q4444',
                    444444,
                    44,
                    'Dd_article_title',
                    'Dd_heading',
                    'Test_image_CC.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['ruwiki', 'idwiki'],
                    80,
                ),
                (
                    'eewiki',
                    'Q5555',
                    555555,
                    55,
                    'Ee_article_title',
                    'Ee_heading',
                    'Test_image_EE.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['gawiki'],
                    80,
                ),
                (
                    'ffwiki',
                    'Q6666',
                    666666,
                    66,
                    'Ff_article_title',
                    'Ff_heading',
                    'Test_image_FF.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['dewiki'],
                    80,
                ),
                (
                    'ggwiki',
                    'Q7777',
                    777777,
                    77,
                    'Gg_article_title',
                    'Gg_heading',
                    'Test_image_GG.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['enwiki'],
                    80,
                ),
                (
                    'hhwiki',
                    'Q8888',
                    888888,
                    88,
                    'Hh_article_title',
                    'Hh_heading',
                    'Test_image_HH.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['nlwiki'],
                    80,
                ),
                (
                    'iiwiki',
                    'Q9999',
                    999999,
                    99,
                    'Ii_article_title',
                    'Ii_heading',
                    'Test_image_II.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['frwiki'],
                    80,
                ),
            ],
            [
                'wiki_db',
                'target_qid',
                'target_page_rev_id',
                'target_page_id',
                'target_page_title',
                'target_section_heading',
                'suggested_image',
                'kind',
                'topic_qid',
                'origin_wikis',
                'confidence',
            ],
        ),
    )
    mocker.patch(
        'image_suggestions.slis.prune_sections_with_images',
        return_value=spark_session.createDataFrame(
            [
                (
                    'ddwiki',
                    'Q4444',
                    444444,
                    44,
                    'Dd_article_title',
                    'Dd_heading',
                    'Test_image_CC.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['ruwiki', 'idwiki'],
                    80,
                ),
                (
                    'eewiki',
                    'Q5555',
                    555555,
                    55,
                    'Ee_article_title',
                    'Ee_heading',
                    'Test_image_EE.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['gawiki'],
                    80,
                ),
                (
                    'ffwiki',
                    'Q6666',
                    666666,
                    66,
                    'Ff_article_title',
                    'Ff_heading',
                    'Test_image_FF.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['dewiki'],
                    80,
                ),
                (
                    'ggwiki',
                    'Q7777',
                    777777,
                    77,
                    'Gg_article_title',
                    'Gg_heading',
                    'Test_image_GG.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['enwiki'],
                    80,
                ),
                (
                    'hhwiki',
                    'Q8888',
                    888888,
                    88,
                    'Hh_article_title',
                    'Hh_heading',
                    'Test_image_HH.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['nlwiki'],
                    80,
                ),
                (
                    'iiwiki',
                    'Q9999',
                    999999,
                    99,
                    'Ii_article_title',
                    'Ii_heading',
                    'Test_image_II.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['frwiki'],
                    80,
                ),
            ],
            [
                'wiki_db',
                'target_qid',
                'target_page_rev_id',
                'target_page_id',
                'target_page_title',
                'target_section_heading',
                'suggested_image',
                'kind',
                'topic_qid',
                'origin_wikis',
                'confidence',
            ],
        ),
    )
    mocker.patch(
        'image_suggestions.slis.prune_suggestions_already_on_page',
        return_value=spark_session.createDataFrame(
            [
                (
                    'eewiki',
                    'Q5555',
                    555555,
                    55,
                    'Ee_article_title',
                    'Ee_heading',
                    'Test_image_EE.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['gawiki'],
                    80,
                ),
                (
                    'ffwiki',
                    'Q6666',
                    666666,
                    66,
                    'Ff_article_title',
                    'Ff_heading',
                    'Test_image_FF.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['dewiki'],
                    80,
                ),
                (
                    'ggwiki',
                    'Q7777',
                    777777,
                    77,
                    'Gg_article_title',
                    'Gg_heading',
                    'Test_image_GG.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['enwiki'],
                    80,
                ),
                (
                    'hhwiki',
                    'Q8888',
                    888888,
                    88,
                    'Hh_article_title',
                    'Hh_heading',
                    'Test_image_HH.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['nlwiki'],
                    80,
                ),
                (
                    'iiwiki',
                    'Q9999',
                    999999,
                    99,
                    'Ii_article_title',
                    'Ii_heading',
                    'Test_image_II.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['frwiki'],
                    80,
                ),
            ],
            [
                'wiki_db',
                'target_qid',
                'target_page_rev_id',
                'target_page_id',
                'target_page_title',
                'target_section_heading',
                'suggested_image',
                'kind',
                'topic_qid',
                'origin_wikis',
                'confidence',
            ],
        ),
    )
    mocker.patch(
        'image_suggestions.slis.prune_overused_images',
        return_value=spark_session.createDataFrame(
            [
                (
                    'ffwiki',
                    'Q6666',
                    666666,
                    66,
                    'Ff_article_title',
                    'Ff_heading',
                    'Test_image_FF.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['dewiki'],
                    80,
                ),
                (
                    'ggwiki',
                    'Q7777',
                    777777,
                    77,
                    'Gg_article_title',
                    'Gg_heading',
                    'Test_image_GG.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['enwiki'],
                    80,
                ),
                (
                    'hhwiki',
                    'Q8888',
                    888888,
                    88,
                    'Hh_article_title',
                    'Hh_heading',
                    'Test_image_HH.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['nlwiki'],
                    80,
                ),
                (
                    'iiwiki',
                    'Q9999',
                    999999,
                    99,
                    'Ii_article_title',
                    'Ii_heading',
                    'Test_image_II.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['frwiki'],
                    80,
                ),
            ],
            [
                'wiki_db',
                'target_qid',
                'target_page_rev_id',
                'target_page_id',
                'target_page_title',
                'target_section_heading',
                'suggested_image',
                'kind',
                'topic_qid',
                'origin_wikis',
                'confidence',
            ],
        ),
    )
    mocker.patch(
        'image_suggestions.slis.prune_images_in_placeholder_categories',
        return_value=spark_session.createDataFrame(
            [
                (
                    'ggwiki',
                    'Q7777',
                    777777,
                    77,
                    'Gg_article_title',
                    'Gg_heading',
                    'Test_image_GG.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['enwiki'],
                    80,
                ),
                (
                    'hhwiki',
                    'Q8888',
                    888888,
                    88,
                    'Hh_article_title',
                    'Hh_heading',
                    'Test_image_HH.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['nlwiki'],
                    80,
                ),
                (
                    'iiwiki',
                    'Q9999',
                    999999,
                    99,
                    'Ii_article_title',
                    'Ii_heading',
                    'Test_image_II.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['frwiki'],
                    80,
                ),
            ],
            [
                'wiki_db',
                'target_qid',
                'target_page_rev_id',
                'target_page_id',
                'target_page_title',
                'target_section_heading',
                'suggested_image',
                'kind',
                'topic_qid',
                'origin_wikis',
                'confidence',
            ],
        ),
    )
    mocker.patch(
        'image_suggestions.slis.prune_suggestions_with_disallowed_substrings',
        return_value=spark_session.createDataFrame(
            [
                (
                    'hhwiki',
                    'Q8888',
                    888888,
                    88,
                    'Hh_article_title',
                    'Hh_heading',
                    'Test_image_HH.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['nlwiki'],
                    80,
                ),
                (
                    'iiwiki',
                    'Q9999',
                    999999,
                    99,
                    'Ii_article_title',
                    'Ii_heading',
                    'Test_image_II.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['frwiki'],
                    80,
                ),
            ],
            [
                'wiki_db',
                'target_qid',
                'target_page_rev_id',
                'target_page_id',
                'target_page_title',
                'target_section_heading',
                'suggested_image',
                'kind',
                'topic_qid',
                'origin_wikis',
                'confidence',
            ],
        ),
    )
    mocker.patch(
        'image_suggestions.slis.prune_suggestions_with_disallowed_suffixes',
        return_value=spark_session.createDataFrame(
            [
                (
                    'iiwiki',
                    'Q9999',
                    999999,
                    99,
                    'Ii_article_title',
                    'Ii_heading',
                    'Test_image_II.jpg',
                    ['istype-section-alignment', 'istype-section-topics'],
                    'Q9999',
                    ['frwiki'],
                    80,
                ),
            ],
            [
                'wiki_db',
                'target_qid',
                'target_page_rev_id',
                'target_page_id',
                'target_page_title',
                'target_section_heading',
                'suggested_image',
                'kind',
                'topic_qid',
                'origin_wikis',
                'confidence',
            ],
        ),
    )
    actual = slis.prune_suggestions(
        spark_session, weekly_snapshot, 'test', dict(), suggestions
    )
    expected = spark_session.createDataFrame(
        [
            (
                'iiwiki',
                'Q9999',
                999999,
                99,
                'Ii_article_title',
                'Ii_heading',
                'Test_image_II.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['frwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )

    assert_df_equality(actual, expected)


def test_prune_non_illustratable_item_ids(spark_session, mocker):
    weekly_snapshot = '2023-02-03'
    suggestions = spark_session.createDataFrame(
        [
            # unillustratable page qid
            (
                'aawiki',
                'Q9999',
                123456,
                789,
                'Aa_article_title',
                'Aa_heading',
                'Test_image_AA.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            # unillustratable topic qid
            (
                'bbwiki',
                'Q1234',
                456789,
                123,
                'Bb_article_title',
                'Bb_heading',
                'Test_image_BB.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
            # both valid
            (
                'ccwiki',
                'Q2345',
                789123,
                456,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-topics'],
                'Q3456',
                None,
                50,
            ),
            # no topic id available
            (
                'ddwiki',
                'Q3456',
                987654,
                789,
                'Dd_article_title',
                'Dd_heading',
                'Test_image_DD.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )
    mocker.patch(
        'image_suggestions.unillustratable.get_non_illustratable_item_ids',
        return_value=spark_session.createDataFrame([('Q9999',)], ['item_id']),
    )
    actual = slis.prune_non_illustratable_item_ids(
        spark_session, weekly_snapshot, suggestions
    )
    expected = spark_session.createDataFrame(
        [
            (
                'ccwiki',
                'Q2345',
                789123,
                456,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-topics'],
                'Q3456',
                None,
                50,
            ),
            (
                'ddwiki',
                'Q3456',
                987654,
                789,
                'Dd_article_title',
                'Dd_heading',
                'Test_image_DD.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )

    assert_df_equality(actual, expected, ignore_row_order=True)


def test_prune_non_illustratable_sections(spark_session, mocker):
    mocker.patch(
        'image_suggestions.unillustratable.read_denylist_parquet',
        return_value=spark_session.createDataFrame(
            [
                ('abwiki', 'internet'),
            ],
            ['wiki_db', 'section_heading'],
        ),
    )
    suggestions = spark_session.createDataFrame(
        [
            (
                'abwiki',
                'Q1234',
                123456,
                789,
                'Aa_article_title',
                'Internet',
                'Test_image_AA.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'bbwiki',
                'Q2345',
                456789,
                123,
                'Bb_article_title',
                'Bb_heading',
                'Test_image_BB.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
            (
                'ccwiki',
                'Q3456',
                789123,
                456,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )
    actual = slis.prune_non_illustratable_sections(
        spark_session, '/path/to/parquet', suggestions
    )
    expected = spark_session.createDataFrame(
        [
            (
                'bbwiki',
                'Q2345',
                456789,
                123,
                'Bb_article_title',
                'Bb_heading',
                'Test_image_BB.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
            (
                'ccwiki',
                'Q3456',
                789123,
                456,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )

    assert_df_equality(actual, expected)


def test_prune_sections_with_images(spark_session, mocker):
    suggestions = spark_session.createDataFrame(
        [
            (
                'abwiki',
                'Q1234',
                123456,
                789,
                'Aa_article_title',
                'Internet',
                'Test_image_AA.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'bbwiki',
                'Q2345',
                456789,
                123,
                'Bb_article_title',
                'Bb_heading',
                'Test_image_BB.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
            (
                'ccwiki',
                'Q3456',
                987654,
                321,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )
    mocker.patch(
        'image_suggestions.unillustratable.get_section_images',
        return_value=spark_session.createDataFrame(
            [
                ('bbwiki', 123, 'Bb_article_title', 'Bb_heading', 'Test_image.jpg'),
            ],
            ['wiki_db', 'page_id', 'page_title', 'section_heading', 'image'],
        ),
    )
    actual = slis.prune_sections_with_images(
        spark_session, '/path/to/parquet', suggestions
    )
    expected = spark_session.createDataFrame(
        [
            (
                'abwiki',
                'Q1234',
                123456,
                789,
                'Aa_article_title',
                'Internet',
                'Test_image_AA.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'ccwiki',
                'Q3456',
                987654,
                321,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )

    assert_df_equality(actual, expected)


def test_prune_suggestions_already_on_page(spark_session, mocker):
    weekly_snapshot = '2023-03-03'
    suggestions = spark_session.createDataFrame(
        [
            (
                'eewiki',
                'Q1234',
                123456,
                789,
                'Ee_article_title',
                'Ee_heading_1',
                'Test_image_EE.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'eewiki',
                'Q1234',
                123456,
                789,
                'Ee_article_title',
                'Ee_heading_2',
                'Test_image_EE.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                80,
            ),
            (
                'eewiki',
                'Q1234',
                123456,
                789,
                'Ee_article_title',
                'Ee_heading_2',
                'Test_image_AA.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                80,
            ),
            (
                'ffwiki',
                'Q2345',
                456789,
                123,
                'Ff_article_title',
                'Bb_heading',
                'Test_image_FF.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
            (
                'ggwiki',
                'Q3456',
                987654,
                321,
                'Gg_article_title',
                'Cc_heading',
                'Test_image_GG.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )
    mocker.patch(
        'image_suggestions.shared.load_imagelinks',
        return_value=spark_session.createDataFrame(
            [
                ('eewiki', 789, 'Test_image_EE.jpg'),
                ('ffwiki', 789, 'Test_image_FF.jpg'),
                ('ffwiki', 123, 'Test_image_XX.jpg'),
                ('aawiki', 321, 'Test_image_GG.jpg'),
            ],
            ['wiki_db', 'article_id', 'image_title'],
        ),
    )
    actual = slis.prune_suggestions_already_on_page(
        spark_session, weekly_snapshot, suggestions
    )
    expected = spark_session.createDataFrame(
        [
            (
                'ffwiki',
                'Q2345',
                456789,
                123,
                'Ff_article_title',
                'Bb_heading',
                'Test_image_FF.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
            (
                'ggwiki',
                'Q3456',
                987654,
                321,
                'Gg_article_title',
                'Cc_heading',
                'Test_image_GG.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
            (
                'eewiki',
                'Q1234',
                123456,
                789,
                'Ee_article_title',
                'Ee_heading_2',
                'Test_image_AA.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )

    assert_df_equality(actual, expected, ignore_row_order=True)


def test_prune_images_in_placeholder_categories(spark_session, mocker):
    suggestions = spark_session.createDataFrame(
        [
            (
                'abwiki',
                'Q1234',
                123456,
                789,
                'Aa_article_title',
                'Internet',
                'Test_image_AA.svg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'bbwiki',
                'Q2345',
                456789,
                123,
                'Bb_article_title',
                'Bb_heading',
                'Test_placeholder_BB.svgz',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
            (
                'ccwiki',
                'Q3456',
                987654,
                321,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )
    mocker.patch(
        'image_suggestions.unillustratable.get_images_in_placeholder_categories',
        return_value=spark_session.createDataFrame(
            [
                (123, 'Category_Name', 'file', 'Test_placeholder_BB.svgz'),
            ],
            ['cl_from', 'cl_to', 'cl_type', 'page_title'],
        ),
    )
    actual = slis.prune_images_in_placeholder_categories(spark_session, suggestions)
    expected = spark_session.createDataFrame(
        [
            (
                'abwiki',
                'Q1234',
                123456,
                789,
                'Aa_article_title',
                'Internet',
                'Test_image_AA.svg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'ccwiki',
                'Q3456',
                987654,
                321,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )

    assert_df_equality(actual, expected)


def test_prune_suggestions_with_disallowed_substrings(spark_session):
    suggestions = spark_session.createDataFrame(
        [
            (
                'abwiki',
                'Q1234',
                123456,
                789,
                'Aa_article_title',
                'Internet',
                'This_is_no_free_image.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'bbwiki',
                'Q2345',
                456789,
                123,
                'Bb_article_title',
                'Bb_heading',
                'Flag_of_some_country.svg',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
            (
                'ccwiki',
                'Q3456',
                987654,
                321,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
            (
                'ddwiki',
                'Q78910',
                987654,
                321,
                'Dd_article_title',
                'Dd_heading',
                'Test_image_with_svg_in_title_DD.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )
    actual = slis.prune_suggestions_with_disallowed_substrings(suggestions)
    expected = spark_session.createDataFrame(
        [
            (
                'ccwiki',
                'Q3456',
                987654,
                321,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
            (
                'ddwiki',
                'Q78910',
                987654,
                321,
                'Dd_article_title',
                'Dd_heading',
                'Test_image_with_svg_in_title_DD.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )

    assert_df_equality(actual, expected)


def test_prune_suggestions_with_disallowed_suffixes(spark_session):
    suggestions = spark_session.createDataFrame(
        [
            (
                'abwiki',
                'Q1234',
                123456,
                789,
                'Aa_article_title',
                'Internet',
                'Test_image_AA.svg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'bbwiki',
                'Q2345',
                456789,
                123,
                'Bb_article_title',
                'Bb_heading',
                'Test_image_BB.svgz',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
            (
                'ccwiki',
                'Q3456',
                987654,
                321,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
            (
                'ddwiki',
                'Q78910',
                987654,
                321,
                'Dd_article_title',
                'Dd_heading',
                'Test_image_with_svg_in_title_DD.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )
    actual = slis.prune_suggestions_with_disallowed_suffixes(suggestions)
    expected = spark_session.createDataFrame(
        [
            (
                'ccwiki',
                'Q3456',
                987654,
                321,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
            (
                'ddwiki',
                'Q78910',
                987654,
                321,
                'Dd_article_title',
                'Dd_heading',
                'Test_image_with_svg_in_title_DD.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['ptwiki', 'enwiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )

    assert_df_equality(actual, expected)


def test_gather_suggestions(spark_session, mocker):
    hive_db = 'test'
    weekly_snapshot = '2023-02-04'
    section_alignment = spark_session.createDataFrame(
        [
            (
                'aawiki',
                123456,
                789,
                'Aa_article_title',
                'Section_heading_a',
                'Test_image_AA.jpg',
                'Q1234',
                'istype-section-alignment',
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'bbwiki',
                234567,
                678,
                'Bb_article_title',
                'Section_heading_b',
                'Test_image_BB.jpg',
                'Q2345',
                'istype-section-alignment',
                ['frwiki', 'dewiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'target_qid',
            'kind',
            'origin_wikis',
            'confidence',
        ],
    )
    mocker.patch('image_suggestions.alignment_slis.get', return_value=section_alignment)
    section_topics = spark_session.createDataFrame(
        [
            (
                'bbwiki',
                234567,
                678,
                'Bb_article_title',
                'Section_heading_b',
                'Test_image_BB.jpg',
                'Q2345',
                'Q9999',
                'istype-section-topics',
                50,
            ),
            (
                'ccwiki',
                345678,
                567,
                'Cc_article_title',
                'Section_heading_c',
                'Test_image_CC.jpg',
                'Q3456',
                'Q9999',
                'istype-section-topics',
                50,
            ),
        ],
        [
            'wiki_db',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'target_qid',
            'topic_qid',
            'kind',
            'confidence',
        ],
    )
    mocker.patch('image_suggestions.topic_slis.get', return_value=section_topics)
    combined_suggestions = spark_session.createDataFrame(
        [
            (
                'aawiki',
                'Q1234',
                123456,
                789,
                'Aa_article_title',
                'Section_heading_a',
                'Test_image_AA.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'bbwiki',
                'Q2345',
                234567,
                678,
                'Bb_article_title',
                'Section_heading_b',
                'Test_image_BB.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'ccwiki',
                'Q3456',
                345678,
                567,
                'Cc_article_title',
                'Cc_heading',
                'Test_image_CC.jpg',
                ['istype-section-topics'],
                'Q9999',
                None,
                50,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )
    mocker.patch(
        'image_suggestions.slis.combine_suggestions', return_value=combined_suggestions
    )
    expected = spark_session.createDataFrame(
        [
            (
                'aawiki',
                'Q1234',
                123456,
                789,
                'Aa_article_title',
                'Section_heading_a',
                'Test_image_AA.jpg',
                ['istype-section-alignment'],
                None,
                ['frwiki', 'dewiki'],
                80,
            ),
            (
                'bbwiki',
                'Q2345',
                234567,
                678,
                'Bb_article_title',
                'Section_heading_b',
                'Test_image_BB.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q9999',
                ['frwiki', 'dewiki'],
                80,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_heading',
            'suggested_image',
            'kind',
            'topic_qid',
            'origin_wikis',
            'confidence',
        ],
    )
    mocker.patch('image_suggestions.slis.prune_suggestions', return_value=expected)
    actual = slis.gather_suggestions(
        spark_session,
        hive_db,
        weekly_snapshot,
        '/section/topics/parquet',
        '/section_alignment/suggestions/parquet',
        '/section/images/parquet',
        dict(),
    )

    assert_df_equality(actual, expected)
    slis.combine_suggestions.assert_called_with(section_alignment, section_topics)
    slis.prune_suggestions.assert_called_with(
        spark_session,
        weekly_snapshot,
        '/section/images/parquet',
        dict(),
        combined_suggestions,
    )


def test_filter_by_score(spark_session):
    # For simplicity, the tested function expects an integer threshold
    threshold = 77
    # Keep the test readable: just use relevant columns
    # Confidence scores are doubles
    suggestions = spark_session.createDataFrame(
        [('this', 77.0), ('that', 42.24), ('here', 55.3), ('there', 99.9)],
        ['suggested_image', 'confidence'],
    )
    expected = spark_session.createDataFrame(
        [('this', 77.0), ('there', 99.9)], ['suggested_image', 'confidence']
    )
    actual = slis.filter_by_score(suggestions, threshold)

    assert_df_equality(actual, expected)


def test_format_suggestions(spark_session, mocker):
    fake_timeuuid = 'xyz'
    mocker.patch(
        'image_suggestions.shared.create_dataset_id', return_value=fake_timeuuid
    )
    suggestions = spark_session.createDataFrame(
        [
            (
                'aawiki',
                'Q1234',
                None,
                666,
                'Aa_heading',
                'Aa_article_title',
                'Test_image_AA.jpg',
                ['istype-section-alignment'],
                None,
                None,
                ['frwiki', 'dewiki'],
                80,
                111,
                11111,
            ),
            (
                'bbwiki',
                'Q2345',
                'Q9999',
                999,
                'Bb_heading',
                'Bb_article_title',
                'Test_image_BB.jpg',
                ['istype-section-topics'],
                'Q888',
                2.34,
                None,
                50,
                222,
                22222,
            ),
            (
                'ccwiki',
                'Q3456',
                'Q9999',
                1977,
                'Cc_heading',
                'Cc_article_title',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                'Q999',
                3.45,
                ['gawiki'],
                80,
                333,
                33333,
            ),
        ],
        [
            'wiki_db',
            'target_qid',
            'topic_qid',
            'target_section_index',
            'target_section_heading',
            'target_page_title',
            'suggested_image',
            'kind',
            'topic_qid',
            'topic_score',
            'origin_wikis',
            'confidence',
            'target_page_id',
            'target_page_rev_id',
        ],
    )
    expected = spark_session.createDataFrame(
        [
            (
                'aawiki',
                'Q1234',
                666,
                'Aa_heading',
                'Aa_article_title',
                'Test_image_AA.jpg',
                ['istype-section-alignment'],
                ['frwiki', 'dewiki'],
                80,
                111,
                11111,
                fake_timeuuid,
                'commonswiki',
            ),
            (
                'bbwiki',
                'Q2345',
                999,
                'Bb_heading',
                'Bb_article_title',
                'Test_image_BB.jpg',
                ['istype-section-topics'],
                None,
                50,
                222,
                22222,
                fake_timeuuid,
                'commonswiki',
            ),
            (
                'ccwiki',
                'Q3456',
                1977,
                'Cc_heading',
                'Cc_article_title',
                'Test_image_CC.jpg',
                ['istype-section-alignment', 'istype-section-topics'],
                ['gawiki'],
                80,
                333,
                33333,
                fake_timeuuid,
                'commonswiki',
            ),
        ],
        [
            'wiki',
            'item_id',
            'section_index',
            'section_heading',
            'title',
            'image',
            'kind',
            'found_on',
            'confidence',
            'page_id',
            'page_rev',
            'id',
            'origin_wiki',
        ],
    )
    actual = slis.format_suggestions(suggestions)

    assert_df_equality(actual, expected, ignore_schema=True)
